# include <math.h>
# include <stdio.h>
# include <stdlib.h>
# include <string.h>

double factorial(int n)
{
      double p=1.0;
      int i;
      for(i=1;i<=n;i++)
          p = p *i;
      return p;
}

double estimateCos(double x,int terms)
{
    double sum = 0.0;
    int i;
    for(i=0;i<=terms;i++)
    {
        double p1= pow(-1,i);
        double p2 = pow(x,2 *i);
        double p3 = factorial(2*i);
        sum+=(p1*p2)/p3;
    }
    return sum;
}

int main()
{
    double a = -4.0;
    double b =  4.0;
    int npoints = 100;
    for(double x = a;x<=b;x+=(b-a)/npoints)
    {
        printf("%10.5lf %10.5lf %10.5lf\n",x,cos(x),estimateCos(x,10));
    }
    return 0;
}
